VERSION 5.00
Begin VB.UserControl AlphaControl 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Image Image1 
      Height          =   255
      Left            =   0
      Top             =   0
      Width           =   315
   End
End
Attribute VB_Name = "AlphaControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Const DT_SINGLELINE = &H20
Private Const DT_CENTER = &H1
Private Const DT_VCENTER = &H4

Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Const SW_SHOW = 5
Private Const SW_HIDE = 0

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function AlphaBlend Lib "msimg32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal widthSrc As Long, ByVal heightSrc As Long, ByVal blendFunct As Long) As Boolean

Dim m_hMemDC As Long
Dim m_hMemBmp As Long, m_hMemBmpPrev As Long
Dim m_rcControl As RECT
Dim i As Integer

Event ChangeSize(cTag As String)
Event GetPic(mPicture As StdPicture, cTag As String)

Private Sub UserControl_Initialize()
    UserControl.AutoRedraw = True
    m_hMemDC = CreateCompatibleDC(UserControl.hdc)
End Sub

Private Sub UserControl_Terminate()
    If m_hMemBmp <> 0 Then
        DeleteObject SelectObject(m_hMemDC, m_hMemBmpPrev)
    End If
    DeleteDC m_hMemDC
End Sub

Public Sub Translucence(mTag As String)
On Error Resume Next
    Dim hdc As Long
    Dim tPt As POINTAPI
    UserControl.Cls
    RaiseEvent ChangeSize(mTag)

    'ÿؼǰλúʹС
    ClientToScreen UserControl.hwnd, tPt
    ScreenToClient UserControl.containerHwnd, tPt
    Call GetClientRect(UserControl.hwnd, m_rcControl)
    OffsetRect m_rcControl, tPt.X, tPt.Y
    'һڴλͼ
    If m_hMemBmp <> 0 Then
        DeleteObject (SelectObject(m_hMemDC, m_hMemBmpPrev))
    End If
    m_hMemBmp = CreateCompatibleBitmap(UserControl.hdc, m_rcControl.Right, m_rcControl.Bottom)
    m_hMemBmpPrev = SelectObject(m_hMemDC, m_hMemBmp)
     
    'ؿؼ
    'ShowWindow UserControl.hwnd, SW_HIDE
    DoEvents
     
    'ؼͼڴλͼ
    Dim hDesktopDC As Long
    hDesktopDC = GetDC(UserControl.hwnd)
    BitBlt m_hMemDC, 0, 0, m_rcControl.Right, m_rcControl.Bottom, hDesktopDC, 0, 0, vbSrcCopy
    ReleaseDC 0, hDesktopDC

    'ʾؼ
    'ShowWindow UserControl.hwnd, SW_SHOW
     
    'ȾĽƵؼ
    BitBlt UserControl.hdc, 0, 0, m_rcControl.Right, m_rcControl.Bottom, m_hMemDC, 0, 0, vbSrcCopy
    
    Image1.Picture = UserControl.image
    RaiseEvent GetPic(Image1.Picture, mTag)
End Sub
